/**********************************************************************
  el̃_vR}h
  $Id: dump_cmd.c,v 1.3 2002/11/03 03:57:34 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int	dump_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
struct	TARGET_TBL_STRUCT{
	char    *name ;
	int     flag ;
} ;
static struct TARGET_TBL_STRUCT trg_tbl[] = {
	{ "reg"			, (PRINT_CRS|PRINT_GPRS) },
	{ "r"			, (PRINT_CRS|PRINT_GPRS) },
	{ "allreg"		, (PRINT_CRS|PRINT_GPRS|PRINT_FPRS) },
	{ "a"			, (PRINT_CRS|PRINT_GPRS|PRINT_FPRS) },
	{ "spr"			, (PRINT_SPRS)           },
	{ "s"			, (PRINT_SPRS)           },
	{ "tr"			, (PRINT_CRS|PRINT_TRS)  },
	{ "t"			, (PRINT_CRS|PRINT_TRS)  },
	{ "mem"			, (PRINT_MEMORYDUMP)     },
	{ "m"			, (PRINT_MEMORYDUMP)     },
	{ NULL			, 0 }		/*** e[uI[ ***/
} ;
static int    setting_adrs=0 ;
static int    start_adrs=0 ;
static int    leng=(8*16) ;
int    i ;
int    flag ;
int    id ;

 id=proc_list.cur_id ;
 if( tk_pt->pt[1]==NULL ){
   SYSMSG("Too few argument(s)\n") ;
   return(SPECIFY_ERROR) ;
 }
 
 for( i=0 ; ; i++ ){
   if( trg_tbl[i].name==NULL ){
     SYSMSG("Specified invalid argument(%s)\n",tk_pt->pt[1]) ;
     return(SPECIFY_ERROR) ;
   }
   if( strcmp(tk_pt->pt[1],trg_tbl[i].name)==0 ){
     flag=trg_tbl[i].flag ;
     break ;
   }
 }
 
 if( (flag & PRINT_MEMORYDUMP)==0 ){
   return( print_regs( &proc_list.proc[id], flag ) ) ;
 }else{
   setting_adrs=1 ;
   if( tk_pt->pt[2]!=NULL ){
     start_adrs=exatoi(tk_pt->pt[2]) ;
   }
   if( tk_pt->pt[3]!=NULL ){
     i=exatoi(tk_pt->pt[3]) ;
     if( i<0 ) ;
     else leng=((i/16)+((i%16)!=0))*16 ;
   }
   {
     int next_adrs ;
     int ret ;
     next_adrs=start_adrs + leng ;
     ret=print_mems( &proc_list.proc[id], start_adrs, leng ) ;
     if( ret==NORMAL_EXIT ) start_adrs += leng ;
     return( ret ) ;
   }
 }
 
 return(NORMAL_EXIT) ;
}
