/**********************************************************************
  ppcsim script run command
  $Id: run_cmd.c,v 1.4 2002/11/03 03:57:37 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int run_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
  int i ;
  
  if( tk_pt->pt[1]==NULL ){
    SYSMSG("Not specified ppcsim script.\n") ;
    return( NORMAL_EXIT ) ;
  }

  for( i=1 ; i<tk_pt->num ; i++ ){
    cmd_exec( tk_pt->pt[i] ) ;
  }
  
  return(NORMAL_EXIT) ;
}
